import java.util.Iterator;
import java.util.NoSuchElementException;

// This class can be modified and is for testing your solution.
// Modifications will NOT be reviewed or assessed.
//
public class PraxisApplication {

    public static void main(String[] args) {

        Polynomial poly1 = new HornerScheme(8,new HornerScheme(-4, new Constant(10)));
        System.out.println(poly1); // (8 + x*(-4 + x*10))
        System.out.println(poly1.degree());

        Polynomial poly2 = HornerScheme.create(new int[]{3,-2,0,7,5});

        System.out.println(poly2); // (3 + x*(-2 + x*(0 + x*(7 + x*5))))
        System.out.println(poly2.eval(3.1)); // 667.0975

        Polynomial poly3 = new HornerScheme(8,new HornerScheme(-4, new Constant(10)));
        System.out.println(poly1.equals(poly3)); // true
        System.out.println(poly2.equals(HornerScheme.create(new int[]{3,-2,0,7,5}))); // true
        System.out.println(poly2.equals(HornerScheme.create(new int[]{3,-2,0,7}))); // false

        for(Integer i: poly2) {
            System.out.print(i + " ");
        }
        System.out.println();
        // 3 -2 0 7 5

        poly2 = HornerScheme.create(new int[]{10});
        System.out.println(poly2); // 10

        Iterator<Integer> iter = poly2.iterator();
        while (iter.hasNext()) {
            System.out.println(iter.next());
        }
        // 10
        System.out.println(poly2.degree()); // 0

        try {
            System.out.println(iter.next());
        } catch (NoSuchElementException e) {
            System.out.println(e.getMessage());
        }
        // no coefficient!
    }
}

